;This is a fixed value! This code cannot handle deviating values.
.EQU FCLOCK=20000000

.INCLUDE "tn4313def.inc"

;Globally reserved registers -------------------------------------------------

.UNDEF XL				;hide X from all
.UNDEF XH

.DEF TMP = R13			;scratch for exclusive parts of all ISRs
.DEF NULL = R14			;RO to anyone, allways zero
.DEF SREGBAK = R15		;backup for SREG for exclusive parts of all ISRs
.DEF LEDCNTL = R24		;LED counter, also used for refresh control
.DEF LEDCNTH = R25		;dedicated to ws28xx driver only
.DEF PTRL = R26			;make X exclusive as PTR for 28xx driver
.DEF PTRH = R27			;only

#define LEDCNT R25:R24	;aliases for use as (index) register pairs
#define PTR X

;Code ------------------------------------------------------------------------

.CSEG

.ORG 0
	rjmp init

;Space for interrupt vectors, but avoid declaring interrupt vectors here.
;Better use the SETVECTOR macro at ISR entries instead. If you need an
;overview over allocated vectors, simply use the map file and filter
;it for "ISR_" pattern.

.ORG INT_VECTORS_SIZE

.INCLUDE "ws28xx.asm"

.CSEG

init:
	rcall ws28xx_init
	sei

main:
	rjmp main


