.IFNDEF WS28XX_HSB2RGB
.EQU WS28XX_HSB2RGB=1

.CSEG

;-----------------------------------------------------------------------------
;->ZL : hue
;  R16: saturation
;  R17: brightness 
;<-R0 : red
;  R1 : green
;  YH : blue
;-----------------------------------------------------------------------------
;R16,R17,ZL,ZH destroyed
;-----------------------------------------------------------------------------

	ldi ZH,0						;  1		calculate f and hi 
	movw R1:R0,ZH:ZL				;  1
	lsl R0							;  1
	rol R1							;  1
	add ZL,R0						;  1
	adc ZH,R1						;  1
	lsl ZL							;  1		
	rol ZH							;  1

	com R16							;  1		calculate p
	UMUL R16,R17					;  2
	mov YH,R1						;  1
	
	com R16							;  1		calculate q or t
	sbrs ZH,0						;  1
	com ZL							;  1
	UMUL R16,ZL						;  2
	mov R16,R1						;  1
	com R16							;  1
	UMUL R16,R17					;  2
									; ..
									; 21

									;[21][21][21]
	cpi ZH,3						;  1   1   1
	brcs _h2r_low					;  1   1   2
	breq _h2r_3						;  1   2
									; ..  ..  ..
									; 24  25  24 

	_h2r_high:						;[24][24]
	cpi ZH,5						;  1   1
	breq _h2r_5						;  1   2
									; ..  ..
									; 26  27 

	_h2r_4:							;[26]
	mov R0,R1						;  1
	mov R1,YH						;  1
	mov YH,R17						;  1
	rjmp _h2r_done					;  2
									; --
									; 31

	_h2r_3:							;[25]
	mov R0,YH						;  1
	mov YH,R17						;  1
	rjmp _h2r_done					;  2
									; --
									; 29

	_h2r_low:						;[24][24][24]
	cpi ZH,1						;  1   1   1
	breq _h2r_2						;  1   1   2
	brcs _h2r_0						;  1   2
									; --  --  --
									; 27  28  27       

	_h2r_1:							;[27]
	mov R0,YH						;  1
	mov YH,R1						;  1
	mov R1,R17						;  1
	rjmp _h2r_done					;  2
									; --
									; 32

	_h2r_2:							;[27]
	mov R0,R1						;  1
	mov R1,R17						;  1
	rjmp _h2r_done					;  2
									; --
									; 31

	_h2r_0:							;[28]
	mov R0,R17						;  1
	rjmp _h2r_done					;  2
									; --
									; 31

	_h2r_5:							;[27]
	mov R0,R17						;  1
	mov R16,YH						;  1
	mov YH,R1						;  1
	mov R1,R16						;  1
									; --
									; 31

	_h2r_done:						; 32 	worst case + (3*38)=146 for ATtiny
									;===

.ENDIF
